<?xml version="1.0" encoding="utf-8"?>
<databaseChangeLog
    xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
    xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-4.3.xsd
                        http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd">

    <!--
        Added the entity Product.
    -->
    <changeSet id="20210908091026-1" author="jhipster">
        <createTable tableName="product">
            <column name="id" type="bigint" autoIncrement="true">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            <column name="name" type="varchar(255)">
                <constraints nullable="false" unique="true" uniqueConstraintName="ux_product__name" />
            </column>
            <column name="description" type="varchar(255)">
                <constraints nullable="true" />
            </column>
            <column name="image" type="longblob">
                <constraints nullable="true" />
            </column>
            <column name="image_content_type" type="varchar(255)">
                <constraints nullable="true" />
            </column>
            <column name="next_activity" type="${datetimeType}">
                <constraints nullable="true" />
            </column>
            <column name="last_activity" type="${datetimeType}">
                <constraints nullable="true" />
            </column>
            <column name="created_at" type="${datetimeType}">
                <constraints nullable="true" />
            </column>
            <column name="updated_at" type="${datetimeType}">
                <constraints nullable="true" />
            </column>
            <column name="link" type="varchar(255)">
                <constraints nullable="true" />
            </column>
            <column name="price" type="${floatType}">
                <constraints nullable="true" />
            </column>
            <column name="sale_price" type="${floatType}">
                <constraints nullable="true" />
            </column>
            <column name="currency" type="varchar(255)">
                <constraints nullable="true" />
            </column>
            <column name="company_id" type="bigint">
                <constraints nullable="true" />
            </column>
            <!-- jhipster-needle-liquibase-add-column - JHipster will add columns here -->
        </createTable>
        <dropDefaultValue tableName="product" columnName="next_activity" columnDataType="${datetimeType}"/>
        <dropDefaultValue tableName="product" columnName="last_activity" columnDataType="${datetimeType}"/>
        <dropDefaultValue tableName="product" columnName="created_at" columnDataType="${datetimeType}"/>
        <dropDefaultValue tableName="product" columnName="updated_at" columnDataType="${datetimeType}"/>
    </changeSet>

    <changeSet id="20210908091026-1-relations" author="jhipster">

        <createTable tableName="rel_product__category">
            <column name="category_id" type="bigint">
                <constraints nullable="false"/>
            </column>
            <column name="product_id" type="bigint">
                <constraints nullable="false"/>
            </column>
        </createTable>

        <addPrimaryKey columnNames="product_id, category_id" tableName="rel_product__category"/>
    </changeSet>

    <!-- jhipster-needle-liquibase-add-changeset - JHipster will add changesets here -->

    <!--
        Load sample data generated with Faker.js
        - This data can be easily edited using a CSV editor (or even MS Excel) and
          is located in the 'src/main/resources/config/liquibase/fake-data' directory
        - By default this data is applied when running with the JHipster 'dev' profile.
          This can be customized by adding or removing 'faker' in the 'spring.liquibase.contexts'
          Spring Boot configuration key.
    -->
    <changeSet id="20210908091026-1-data" author="jhipster" context="faker">
        <loadData
                  file="config/liquibase/fake-data/product.csv"
                  separator=";"
                  tableName="product">
            <column name="id" type="numeric"/>
            <column name="name" type="string"/>
            <column name="description" type="string"/>
            <column name="image" type="blob"/>
            <column name="image_content_type" type="string"/>
            <column name="next_activity" type="${datetimeType}"/>
            <column name="last_activity" type="${datetimeType}"/>
            <column name="created_at" type="${datetimeType}"/>
            <column name="updated_at" type="${datetimeType}"/>
            <column name="link" type="string"/>
            <column name="price" type="numeric"/>
            <column name="sale_price" type="numeric"/>
            <column name="currency" type="string"/>
            <!-- jhipster-needle-liquibase-add-loadcolumn - JHipster (and/or extensions) can add load columns here -->
        </loadData>
    </changeSet>
</databaseChangeLog>
